



// MetaQuote [ MQ 4 ] 
//                                    IDENTIFICATION~DIVISION                                    10
// v1 




                    #define   $_ProgramName         "Time Tick Talk"
                    #define   $_ProgramSymbol       "TTT"
                    #define   $_FileName            "Time Tick Talk.mq4"
                    #define   @_SystemName          "None"
                    #define   $_Author              "Keit Thomas Largo"
                    #define   $_eMail               "CockeyedCowboy@gmail,coom"
                    #define   $_CompanyName         "WinSoft Technology  "
                    #define   $_LicenseTo           "Open Source"
                    #define   $_ModuleType          "Script File"
                    #define   $_DateWriten          "03.20.2012"
                    #define   $_VersionNumber       "1.00 b01 rt"
                    #define   $_LastUpDate          "03.20.2012"
                    #define   $_ProgramLanguage     "MetaQuote  MQL v4.00, b409"
                    #define   $_Documentation       "see {Documentation Division}"
                    #define   $_CopyRight           "CopyRight    2012"




/*
  COPYRIGHT: 





  VERSION COMMENTS: 





                                       COMPILER~DIRECTIVES                                       20
  FILE LINKAGE: */




                    #property      copyright      "Keit Thomas Largo"
                    #property      link           "CockeyedCowboy@gmail,coom"
                    #property      show_inputs


                    #import "user32.dll"
                        int  RegisterWindowMessageA( string SendNote );
                        int  PostMessageA( int hWnd, int Msg, int wParam, int lParam );

                    #import




//
//                                     ENVIRONMENT~DIVISION                                      30
//  DEFINED CONSTANT: 




//
//  EXTERN PARAMETER: 




        extern
            int
                SleepTime   =   500;




//
//  DEFAULT ATTRIBUTES: 




//
//  GLOBAL SCOPE VARIABLES: 




//
//  GLOBAL SCOPE ARRAYS: 




//
//                                    CONFIGURATION~DIVISION                                     40
void init(){//




return;}//
//                                        CODING~DIVISION                                        50
void start(){//




            int   $_ControlID   =   WindowHandle( Symbol(), 0 );

                    while( ! IsStopped() ) {

                        ThrowNewTick( $_ControlID, SleepTime, 1, False );

                    } // End While Loop, IsStopped:




return;}//
//                                        OUTPUT~DIVISION                                        60
void output(){//




return;}//
//                                     TERMINATION~DIVISION                                      70
void deinit(){//




return;}//
//                                PROCEDURAL~DEFINITION~DIVISION                                 80
//  FUNCTION PROCEDURES: 






/*===============================================================================================|\
||                                                                                               ||
||  ThrowNewTick Routine Procedure            v1.20            Date 01.23.2010             KTL   ||
||                                                                                               ||
||  Returns:     True if it success, False other wise.                                           ||
||                                                                                               ||
||  Purpose:     This creates false ticks to run programs on a time base instead of tick wise.   ||
||               It has a parameter to refresh the price data after the the tick was generated   ||
||               to give your EA or script fresh data to work with. This code is a redo of code  ||
||               found on Forex Factory writed by 7bits were credit is due.                      ||
||                                                                                               ||
||  Parameters:  Control  --- This parameter contains the window handle.                         ||
||               TickOff  --- This is the number of millie seconds to wait between ticks.        ||
||               TickLoop --- The number of ticks to throw before the EA or script runs.         ||
||               Refresh  --- Refreshes the data so the EA or script can work with fresh price   ||
||                               data.                                                           ||
||                                                                                               ||
||  Note:        Added the Refresh parameter as the first version was not letting the script     ||
||               see new price data. If one is only generating ticks to run indicator on the     ||
||               MT chart then this can be fales.                                                ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    ThrowNewTick( string Control, int TickOff, int TickLoop, bool Refresh ) {
        int    Index     =   1;
        int    Error     =   GetLastError();
        int    CID       =   StrToInteger( StringTrimRight( Control ));
        int    Message   =   RegisterWindowMessageA( "MetaTrader4_Internal_Message" );

            for( ; Index <= TickLoop; Index ++ ) {
                Sleep ( TickOff );
                PostMessageA( CID, Message, 2, 1 );

            } // End For Loop, Loop:

            if( Refresh )   {   RefreshRates();   }

   return;

} // End Routine Procedure, ThrowNewTick:




//
//                                     DOCUMENTATION~DIVISION                                    90
/*  FUNCTION OF PROGRAM: 





  VERSION UPDATES: 




        Current Revisions:
            Version 1.00 b01 ra     03.20.2011
                *	




        Future Enhancement:
                - 	





  SCRIPT NOTES: 





  CODE STORAGE: 




/*===============================================================================================|\
||                                                                                               ||
||  Public Private Function Routine GUI Procedure Property    v1.00    Date 00.00.2012     KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     None.                                                                           ||
||                                                                                               ||
||  Parameters:  None.                                                                           ||
||                                                                                               ||
||  Note:        None.                                                                           ||
||                                                                                               ||
||  Example:     None.                                                                           ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/




//*/
//                                      END~PROGRAM~SCRIPT~[mq4]                                 00
// [ v1.rev.01-01-2012] 




